<?php
class SpamMasterActionController {

	protected $spama;

	public function SpamMasterAct($spama) {
		global $wpdb, $blog_id;

		//Add Table & Load Spam Master Options
		if(is_multisite()){
			$spam_master_keys = $wpdb->get_blog_prefix($blog_id)."spam_master_keys";
		}
		else{
			$spam_master_keys = $wpdb->prefix."spam_master_keys";
		}
		$spam_master_status = $wpdb->get_var("SELECT spamvalue FROM {$spam_master_keys} WHERE spamkey = 'Option' AND spamtype = 'spam_master_status'");
		
		if($spam_master_status == 'VALID' || $spam_master_status == 'MALFUNCTION_1' || $spam_master_status == 'MALFUNCTION_2'){
			if($spama == '1'){
				//Update Spama for Cron
				$data_spam = array('spamvalue' => $spama);
				$where_spam = array('spamkey' => 'Option', 'spamtype' => 'spam_master_new_options');
				$wpdb->update( $spam_master_keys, $data_spam, $where_spam );
			}
		}

	}

	public function SpamMasterGetAct() {
		global $wpdb, $blog_id;

		//Add Table & Load Spam Master Options
		if(is_multisite()){
			$spam_master_keys = $wpdb->get_blog_prefix($blog_id)."spam_master_keys";
		}
		else{
			$spam_master_keys = $wpdb->prefix."spam_master_keys";
		}
		$spam_master_status = $wpdb->get_var("SELECT spamvalue FROM {$spam_master_keys} WHERE spamkey = 'Option' AND spamtype = 'spam_master_status'");
		$spam_license_key = $wpdb->get_var("SELECT spamvalue FROM {$spam_master_keys} WHERE spamkey = 'Option' AND spamtype = 'spam_license_key'");
		$spam_master_db_protection_hash = $wpdb->get_var("SELECT spamvalue FROM {$spam_master_keys} WHERE spamkey = 'Option' AND spamtype = 'spam_master_db_protection_hash'");
		$spam_master_address = substr($wpdb->get_var("SELECT spamvalue FROM {$spam_master_keys} WHERE spamkey = 'Option' AND spamtype = 'spam_master_address'"),0,256);
		$spam_master_ip = substr($wpdb->get_var("SELECT spamvalue FROM {$spam_master_keys} WHERE spamkey = 'Option' AND spamtype = 'spam_master_ip'"),0,48);
		
		if($spam_master_status == 'VALID' || $spam_master_status == 'MALFUNCTION_1' || $spam_master_status == 'MALFUNCTION_2'){

			$spam_master_learn_act_url = 'aHR0cHM6Ly93d3cuc3BhbW1hc3Rlci5vcmcvd3AtY29udGVudC9wbHVnaW5zL3NwYW0tbWFzdGVyLWFkbWluaXN0cmF0b3IvaW5jbHVkZXMvbGVhcm5pbmcvZ2V0X2xlYXJuX2FjdC5waHA=';
			$spam_master_learning_post = array(
												'blog_license_key' => $spam_license_key,
												'blog_hash_key' => $spam_master_db_protection_hash
			);
			$response = wp_remote_post( base64_decode($spam_master_learn_act_url), array(
																						'method' => 'POST',
																						'timeout' => 90,
																						'body' => $spam_master_learning_post
			));
			if ( is_wp_error( $response ) ) {
				$error_message = $response->get_error_message();
				echo __('Something went wrong, please get in touch with Spam master Support: ', 'spam_master').$error_message;
			}
			else{
				$data = json_decode( wp_remote_retrieve_body( $response ), true );

				if(empty($data['key']) || empty($data['hash'])){

					//Update Spama Done
					$data_spam = array('spamvalue' => '0');
					$where_spam = array('spamkey' => 'Option', 'spamtype' => 'spam_master_new_options');
					$wpdb->update( $spam_master_keys, $data_spam, $where_spam );

				}
				else{
					//Check Key & Hash
					$is_key = $wpdb->get_var($wpdb->prepare( "SELECT id FROM $spam_master_keys WHERE spamkey = 'Option' AND spamtype = 'spam_license_key' AND spamvalue = %s", $data['key']));
					$is_hash = $wpdb->get_var($wpdb->prepare( "SELECT id FROM $spam_master_keys WHERE spamkey = 'Option' AND spamtype = 'spam_master_db_protection_hash' AND spamvalue = %s", $data['hash']));
					if(!empty($is_key) && !empty($is_hash)){

						if($data['action'] == 'Add'){
							if($data['where'] == 'Buffer'){
								$wpdb->query($wpdb->prepare( "DELETE FROM $spam_master_keys WHERE spamkey = 'White' AND spamy = %s", $data['pack']));
							}
							if($data['where'] == 'White'){
								$wpdb->query($wpdb->prepare( "DELETE FROM $spam_master_keys WHERE spamkey = 'Buffer' AND spamy = %s", $data['pack']));
							}
							//No duplicates
							$is_double = $wpdb->get_var($wpdb->prepare("SELECT id FROM {$spam_master_keys} WHERE spamkey = %s AND spamtype = %s AND spamy = %s", $data['where'], $data['type'], $data['pack']));
							if(empty($is_double)){
								$wpdb->insert($spam_master_keys, array( 'time' => current_time( 'mysql' ), 'spamkey' => $data['where'], 'spamtype' => $data['type'], 'spamy' => $data['pack'], 'spamvalue' => $data['value']));
							}
						}
						if($data['action'] == 'Remove'){
							$wpdb->query($wpdb->prepare( "DELETE FROM $spam_master_keys WHERE spamkey = %s AND spamtype = %s AND spamy = %s", $data['where'], $data['type'], $data['pack']));
						}
						if($data['action'] == 'Change'){
							$data_up = array('spamy' => $data['pack'], 'spamvalue' => $data['value']);
							$where_up = array('spamkey' => $data['where'], 'spamtype' => $data['type']);
							$wpdb->update( $spam_master_keys, $data_up, $where_up );
						}

						//Add Controllers
						require_once( WP_PLUGIN_DIR . '/spam-master/includes/controllers/SpamMasterActionController.php');

						//Spam Action Controller
						////////////////////////
						$SpamMasterActionController = new SpamMasterActionController;
						$is_more = $SpamMasterActionController->SpamMasterGetActMore();
					}
				}
			}
		}
	}

	public function SpamMasterGetActMore() {
		global $wpdb, $blog_id;

		//Add Table & Load Spam Master Options
		if(is_multisite()){
			$spam_master_keys = $wpdb->get_blog_prefix($blog_id)."spam_master_keys";
		}
		else{
			$spam_master_keys = $wpdb->prefix."spam_master_keys";
		}
		$spam_master_status = $wpdb->get_var("SELECT spamvalue FROM {$spam_master_keys} WHERE spamkey = 'Option' AND spamtype = 'spam_master_status'");
		
		if($spam_master_status == 'VALID' || $spam_master_status == 'MALFUNCTION_1' || $spam_master_status == 'MALFUNCTION_2'){

		//Add Controllers
		require_once( WP_PLUGIN_DIR . '/spam-master/includes/controllers/SpamMasterActionController.php');

		//Spam Action Controller
		////////////////////////
		$SpamMasterActionController = new SpamMasterActionController;
		$is_more = $SpamMasterActionController->SpamMasterGetAct();

		}
	}

}
?>
