<?php
add_action( 'wp_loaded', 'spam_master_warning_unstable_email' );
function spam_master_warning_unstable_email(){
global $wpdb, $blog_id;

//Add Table & Load Spam Master Options
if(is_multisite()){
	$spam_master_keys = $wpdb->get_blog_prefix($blog_id)."spam_master_keys";
	$admin_email = get_blog_option($blog_id, 'admin_email');
	$blogname = get_blog_option($blog_id, 'blogname');
}
else{
	$spam_master_keys = $wpdb->prefix."spam_master_keys";
	$admin_email = get_option('admin_email');
	$blogname = get_option('blogname');

}
if(empty($blogname)){
	$blogname = 'your blog';
}
$spam_master_emails_extra_email = $wpdb->get_var("SELECT spamvalue FROM {$spam_master_keys} WHERE spamkey = 'Option' AND spamtype = 'spam_master_emails_extra_email'");
$spam_master_emails_extra_email_list = $wpdb->get_var("SELECT spamvalue FROM {$spam_master_keys} WHERE spamkey = 'Option' AND spamtype = 'spam_master_emails_extra_email_list'");
$spam_master_free_unstable = $wpdb->get_var("SELECT spamvalue FROM {$spam_master_keys} WHERE spamkey = 'Option' AND spamtype = 'spam_master_free_unstable'");
$spam_master_unstable_notice = $wpdb->get_var("SELECT spamvalue FROM {$spam_master_keys} WHERE spamkey = 'Option' AND spamtype = 'spam_master_unstable_notice'");
$spam_master_attached = $wpdb->get_var("SELECT spamvalue FROM {$spam_master_keys} WHERE spamkey = 'Option' AND spamtype = 'spam_master_attached'");
$spam_master_ip = substr($wpdb->get_var("SELECT spamvalue FROM {$spam_master_keys} WHERE spamkey = 'Option' AND spamtype = 'spam_master_ip'"),0,48);

	//Get date
	$spam_master_emails_current_date = current_time('Y-m-d');
	$spam_master_emails_plus_15_days = date('Y-m-d', strtotime('+15 days', strtotime($spam_master_emails_current_date)) );
	//Check Notice
	if($spam_master_emails_current_date >= $spam_master_free_unstable && $spam_master_unstable_notice != '1'){
		$data_spam1 = array('spamvalue' => $spam_master_emails_plus_15_days);
		$where_spam1 = array('spamkey' => 'Option', 'spamtype' => 'spam_master_free_unstable');
		$wpdb->update( $spam_master_keys, $data_spam1, $where_spam1 );
		$data_spam2 = array('spamvalue' => '1');
		$where_spam2 = array('spamkey' => 'Option', 'spamtype' => 'spam_master_unstable_notice');
		$wpdb->update( $spam_master_keys, $data_spam2, $where_spam2 );

		//get extra emails
		if($spam_master_emails_extra_email == 'true'){
			if(!empty($spam_master_emails_extra_email_list)){
				$spam_master_more_emails = ','.$spam_master_emails_extra_email_list;
			}
			else{
				$spam_master_more_emails = '';
			}
		}
		else{
			$spam_master_more_emails = '';
		}
		//get attached
		if(!empty($spam_master_attached)){
			if ($spam_master_attached == $admin_email){
				$spam_master_attached_add = '';
			}
			else{
				$spam_master_attached_add = ','.$spam_master_attached;
			}
		}
		else{
			$spam_master_attached_add = '';
		}

		//email user
		//set mail html
		add_filter( 'wp_mail_content_type', 'spam_master_send_user_notice_unstable_html' );
		function spam_master_send_user_notice_unstable_html() {
			return 'text/html';
		}
		//Email Subject Title Header
		$spam_master_subject_title = 'Warning! Unstable Connection';
		$spam_master_html = '<!DOCTYPE html><html>';
		$spam_master_header = '<head><meta http-equiv="Content-Type" content="text/html; charset=UTF-8" /><title>'.$spam_master_subject_title.'</title></head>';
		$spam_master_body = '<body leftmargin="0" marginwidth="0" topmargin="0" marginheight="0" offset="0" style="background-color: #f6f6f6; font-family: &apos;Helvetica Neue&apos;, Helvetica, Arial, &apos;Lucida Grande&apos;, sans-serif;">';
		$spam_master_table_header = '<div style="width:100%; -webkit-text-size-adjust:none !important; margin:0; padding: 70px 0 70px 0;">
<table border="0" cellpadding="0" cellspacing="0" height="100%" width="100%">
<tr>
<td align="center" valign="top">
<table border="0" cellpadding="0" cellspacing="0" width="520" id="template_container" style="box-shadow:0 0 0 1px #f3f3f3 !important; border-radius:3px !important; background-color: #ffffff; border: 1px solid #e9e9e9; border-radius:3px !important; padding: 20px;">
<tr>
<td align="center" valign="top">
<table border="0" cellpadding="0" cellspacing="0" width="520" id="template_header" style=" color: #00000; border-top-left-radius:3px !important; border-top-right-radius:3px !important; border-bottom: 0; font-weight:bold; line-height:100%; text-align: center; vertical-align:middle;" bgcolor="#ffffff">
<tr>
<td>
<h1 style="color: #000000; margin:0; padding: 28px 24px; display:block; font-family: &apos;Helvetica Neue&apos;, Helvetica, Arial, &apos;Lucida Grande&apos;, sans-serif; font-size:32px; font-weight: 500; line-height: 1.2;">
'.$spam_master_subject_title.'
</h1></td></tr></table></td></tr>';
$spam_master_table_body = '<tr>
<td align="center" valign="top">
<table border="0" cellpadding="0" cellspacing="0" width="520" id="template_body">
<tr>
<td valign="top" style="border-radius:3px !important; font-family: &apos;Helvetica Neue&apos;, Helvetica, Arial, &apos;Lucida Grande&apos;, sans-serif;">
<table border="0" cellpadding="20" cellspacing="0" width="100%">
<tr>
<td valign="top">
<div style="color: #000000; font-size:14px; font-family: &apos;Helvetica Neue&apos;, Helvetica, Arial, &apos;Lucida Grande&apos;, sans-serif; line-height:150%; text-align:left;">';
//Email Content
$spam_master_table_content = '<p>Spam Master FREE RBL Server connection is Unstable.</p>
<p>We apologize for that, there\'s probably a high demand of spam check requests to our free servers at this point. The issue should auto resolve within a few hours. You can also press Re-Sync License in the plugin Settings page to immediately reactivate your website protection.</p>
<p>Please check the Free RBL server cluster status <a href="https://www.spammaster.org/rbl-servers-status/" title="Free Server Cluster Status" target="_blank"><strong><em>here</strong></em></a>. Please consider a Pro License, it costs peanuts per year and connects to our Premium Business Server Clusters.</p>
<p>Thanks</p>
<p>SpamMaster Team</p>';
$spam_master_table_content_close = '</div>
</td>
</tr>
</table>
</td>
</tr>
</table>
</td>
</tr>';
$spam_master_table_footer_start = '<tr>
<td align="center" valign="top">
<table border="0" cellpadding="10" cellspacing="0" width="600" id="template_footer" style="border-top:0; -webkit-border-radius:3px;">
<tr>
<td valign="top">
<table border="0" cellpadding="10" cellspacing="0" width="100%">
<tr>
<td colspan="2" valign="middle" id="credit" style="border:0; color: #000000; font-family: &apos;Helvetica Neue&apos;, Helvetica, Arial, &apos;Lucida Grande&apos;, sans-serif; font-size:14px; line-height:125%; text-align:center;">';
$spam_master_table_footer_content = '<p><a href="https://www.techgasp.com/downloads/spam-master-license/" target="_blank">get full license</a></p>';
$spam_master_email_close = '</td>
</tr>
</table>
</td>
</tr>
</table>
</td>
</tr>
</table>
</td>
</tr>
</table>
</div>
</body>
</html>';
		//send email
		$from = $admin_email;
		$to = $admin_email.$spam_master_more_emails.$spam_master_attached_add;
		$subject = $spam_master_subject_title;
		$headers = array ('From' => $from, 'To' => $to, 'Subject' => $subject);
		$message = $spam_master_html.
					$spam_master_header.
					$spam_master_body.
					$spam_master_table_header.
					$spam_master_table_body.
					$spam_master_table_content.
					$spam_master_table_content_close.
					$spam_master_table_footer_start.
					$spam_master_table_footer_content.
					$spam_master_email_close;
		wp_mail( $to, $subject, $message, $headers );
		// Reset content-type to avoid conflicts
		remove_filter( 'wp_mail_content_type', 'spam_master_send_user_notice_unstable_html' );

		//Add Controllers
		require_once( WP_PLUGIN_DIR . '/spam-master/includes/controllers/SpamMasterLogController.php');
		//Log InUp Controller
		$remote_ip = $spam_master_ip;
		$blog_threat_email = 'localhost';
		$remote_referer = 'localhost';
		$dest_url = 'localhost';
		$remote_agent = 'localhost';
		$spamuser = array('ID' => 'none',);
		$spamuserA = json_encode($spamuser, true);
		$spamtype = 'Malfunction Unstable';
		$spamvalue = 'License email unstable notice successfully sent.';
		$cache = '1D';
		$SpamMasterLogController = new SpamMasterLogController;
		$is_log = $SpamMasterLogController->SpamMasterLog($remote_ip, $blog_threat_email, $remote_referer, $dest_url, $remote_agent, $spamuserA, $spamtype, $spamvalue, $cache);
	}
}
?>
